RSAFunction_ISO Class Reference

RSA trapdoor function using the public key. More...

Inheritance diagram for RSAFunction_ISO:

## Public Member Functions

Integer | ApplyFunction (const Integer &x) const
| Applies the trapdoor. More...
Integer | PreimageBound () const
| Returns the maximum size of a message before the trapdoor function is applied. More...
Public Member Functions inherited from RSAFunction
void | Initialize (const Integer &n, const Integer &e)
| Initialize a RSA public key with {n,e}. More...
OID | GetAlgorithmID () const
| Retrieves the OID of the algorithm. More...
void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| decode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
void | DEREncodePublicKey (BufferedTransformation &bt) const
| encode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
Integer | ImageBound () const
| Returns the maximum size of a message after the trapdoor function is applied. More...
const Integer & | GetModulus () const
const Integer & | GetPublicExponent () const
void | SetModulus (const Integer &n)
void | SetPublicExponent (const Integer &e)
Public Member Functions inherited from TrapdoorFunction
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
| Applies the trapdoor function. More...
bool | IsRandomized () const
| Determines if the encryption algorithm is randomized. More...
Public Member Functions inherited from TrapdoorFunctionBounds
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key. More...
virtual Integer | MaxImage () const
| Returns the maximum size of a message after the trapdoor function is applied bound to a public key. More...
Public Member Functions inherited from X509PublicKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
Public Member Functions inherited from ASN1CryptoMaterial< PublicKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
virtual void | Precompute (unsigned int precomputationStorage)
| Perform precomputation. More...
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Additional Inherited Members

Static Public Member Functions inherited from NameValuePairs
static void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

RSA trapdoor function using the public key.

Definition at line 135 of file rsa.h.

## Member Function Documentation

## ApplyFunction()

Integer RSAFunction_ISO::ApplyFunction | ( | const Integer & | x | ) | const

virtual

Applies the trapdoor.

Parameters

  x | the message on which the encryption function is applied

Returns
  the message `x` encrypted under the public key

`ApplyFunction` is a generalization of encryption under a public key cryptosystem. Derived classes must implement it.

Reimplemented from RSAFunction.

Definition at line 294 of file rsa.cpp.

## PreimageBound()

Integer RSAFunction_ISO::PreimageBound | ( |  | ) | const

inline virtual

Returns the maximum size of a message before the trapdoor function is applied.

Returns
  the maximum size of a message before the trapdoor function is applied

Derived classes must implement `PreimageBound()`.

Reimplemented from RSAFunction.

Definition at line 139 of file rsa.h.

The documentation for this class was generated from the following files:

- rsa.h
- rsa.cpp